package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConexionExcepcionRutaDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionExcepcionRuta;
import com.rjconsultores.ventaboletos.service.ConexionExcepcionRutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("conexionExcepcionRutaService")
public class ConexionExcepcionRutaServiceImpl implements ConexionExcepcionRutaService {

	@Autowired
	private ConexionExcepcionRutaDAO conexionExcepcionRutaDAO;

	@Override
	public List<ConexionExcepcionRuta> obtenerTodos() {
		return conexionExcepcionRutaDAO.obtenerTodos();
	}

	@Override
	public List<ConexionExcepcionRuta> obtenerConexionExcepcionsActivo(Long conexionctrlId) {
		return conexionExcepcionRutaDAO.obtenerConexionExcepcionsActivo(conexionctrlId);
	}

	@Override
	public ConexionExcepcionRuta obtenerID(Long id) {
		return conexionExcepcionRutaDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public ConexionExcepcionRuta suscribir(ConexionExcepcionRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionExcepcionRutaDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConexionExcepcionRuta actualizacion(ConexionExcepcionRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionExcepcionRutaDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConexionExcepcionRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		conexionExcepcionRutaDAO.actualizacion(entidad);

	}
}
